//http://blogs.embarcadero.com/nickhodges/2010/01/06/39345
// http://www.freesmileys.org/
// http://www.smiley-faces.org/smiley-faces-001.php
// http://www.greywyvern.com/code/php/binary2base64

unit SmartSmiley;

interface

uses w3system, w3components;

type
  TSmileyEmotion = (seSmiling, seGrinning, seLaughing, seSad, seCrying,
    seCool, seMad, seWinking, seSurprised);

  TSmiley = class(TW3CustomControl)
  private const
    CEmotionName: array [seSmiling..seSurprised] of string =
      ['smiling', 'grinning', 'laughing', 'sad', 'crying', 'cool',
       'mad', 'winking', 'surprised'];
    FEmotion: TSmileyEmotion;
  protected
    function  GetEmotionData(emotion: TSmileyEmotion): string;
    procedure InitializeObject; override;
    procedure SetEmotion(const emotion: TSmileyEmotion);
    procedure StyleTagObject; override;
  public
    function EmotionName: string;
    property Emotion: TSmileyEmotion read FEmotion write SetEmotion;
  end;

implementation

const 
  //http://www.smiley-faces.org/smiley-faces/smiley-face-smile.gif
  CSmiling =
    'data:image/gif;base64,R0lGODlhFAAUAOZ7AP7lIv/lIv7kIfzhIPHPGvrdH/nbH+Tl4+' +
    'nCFu/y9N3d2O/MGWVQHaKYfP3iIZKFY+7x8vbXHeK3EnhnPOa8FPDOGgAAAKOZfnVjNvXWHZ' +
    '52CuW8FF9JFNjY0fLRG9HPxdTSyeS6FGJNGeW7FHdmOqGWeuvGF9WhC2xOB29WCptxB2pQCb' +
    'SNDtTTyufEGLCTEt6vEKJ8C5pvB2lNCM2qFK2PEq19B5+VeOa/Fpp+EKeKEWlVIHJfMd+yEd' +
    'i3F76QC9KyFuvFF+/y89XUzKWbgdCbCmZQHKeehLuKCXNhM9DOxNWiDGdTHuK3E29UCd6xEK' +
    'SDD2hLCKaCDenHGfPUHXppP+S8FtmsEJtwB86dC9inDezJGe/RHG1QCLaPDu7MGt2vEKiGD9' +
    'uuEKGXe4lkB2xTCsCSC9OwFdmnDdfWz49tCtjX0GlUINSfC82aC3tqQJJyDMKkFZOGZXhmO8' +
    '6ZCb2MCd6wENLQx/jbHkM0EP/mIvX5/QAAAAAAAAAAAAAAACH5BAEAAHsALAAAAAAUABQAAA' +
    'f/gHuCg4SFhoQJQ0dvIiJVRC0Jh4IHDWU6QF9bNFArDQeHHRg5XHgFBXgZFVZwGB2FCjtxeA' +
    'MCAAACA3geCCxsCoNCci8GDgF6yHoBDgYEFDEPEIJ3KVQDx3nJeQEDESZiXR+CYzV4AsjZ6H' +
    'oCeAsSGiWCEz4FAOrqAAUEIWYTggxT6iUbqCffviwM/rkwRzAZuwVN3CTcM+FMBAvHCHK7+K' +
    'TOHEElwhAwsG3gMpIU0Ki4IeiDExwe8OSxhWsASQQwiqBQIgjCAykIKmTIQ7Qogh4nsEQbpI' +
    'CJlw1BFhAgsMDEBjAnbBgBRmhNEjVXJIwYIcGOFjpkeKQ5VGmGhh9LGNogkRHl06Q9CUBcIM' +
    'GBA4kLICTdHVwoEAA7';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-biggrin.gif
  CGrinning =
    'data:image/gif;base64,R0lGODlhFAAUAOZ7APjbHvrdH/HPGv7lIv7kIaKYfGVQHd3d2O' +
    'Tl4+/y9OnCFvzhIJKFY+7x8vnbH+/MGeK3EnhnPGJNGV9JFNHPxaOZfvLRG+a8FPbXHXVjNv' +
    'XWHfDOGuS6FNTSydWhC9jY0eW8FOW7FKGWeuvGF552CndmOtmsEN+yEWxOB2lNCJtxB4lkB/' +
    'PUHZJyDNTTyq19B9CbCrCTEp+VeNKyFt6wENfWz/3iIea/FtuuEG1QCKWbgdSfC6aCDXppP2' +
    'lVIGlUIG9WCnJfMW9UCdWiDGZQHKeehHNhM86ZCdDOxKSDD9inDaiGD9jX0KGXe2hLCKeKEd' +
    '6vENmnDb2MCaJ8C2pQCY9tCunHGd2vEMKkFbuKCbaPDuK3E96xEJtwB82aC5p+EOvFF+/RHP' +
    '/lIu/y85pvB9i3F+fEGNXUzOS8FrSNDq2PEnhmO86dC2xTCtLQx8CSC76QC3tqQJOGZdOwFc' +
    '2qFOzJGWdTHu7MGv/mIkM0EP////X5/QAAAAAAAAAAAAAAACH5BAEAAHsALAAAAAAUABQAAA' +
    'f/gHuCg4SFhoQJZ0VxEhI9Oi4Jh4IIBW1PM3d1dElUBQiHHxlfYQABAQAaG2gtGR+FBz5YAA' +
    'sEAwMECwAWCmk/B4NjcjEONnnHeMd5DgIXUwwNgm5ALAt5eNjZYnkYIzg5FIJNagAE2ed4BA' +
    'APECQighFlAQPo2QMBAhxvEYIGVgHI6g04xoGNgX5mAOTRo6zhwjxbvBzcE2EOhoV6MmrUmI' +
    'eLlDWCRCwR4ADjxox5LkRRIUMQBSE3LCg8yVABFBgokAhqwICHgg0aHOZRcMJDF2iDDtjRAg' +
    'LMAwECHowAccXDCyLACDExUsUEhBAhINBQcmRFkBqHKqUgAWfIjixkFZx8mrQnQYcKJSZMKF' +
    'GhgyS6gAsFAgA7';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-laugh.gif
  CLaughing =
    'data:image/gif;base64,R0lGODlhFAAUAOZ8APjbHv7kIfrdH/7lIqKYfPzhIGVQHeTl49' +
    '3d2PHPGu/y9JKFY+7x8vnbH+K3EnhnPJ52CuW7FHdmOvbXHV9JFP8hIXVjNtTSyaOZfqGWev' +
    'LRG/DOGua8FGJNGdWhC9HPxdjY0eS6FO/MGevGF+nCFuW8FOa/FuK3E62PEtjX0KeKEe7MGr' +
    'SNDv/lIqJ8C5p+EKSDD9i3F+fEGLaPDm1QCN6wEMKkFWhLCNKyFtfWz9LQx3tqQNSfC9TTyu' +
    '/y8+vFF86ZCXhmO5twB6GXe3NhM2ZQHKeehMCSC2xOB72MCdinDdOwFaaCDd2vEOnHGduuEN' +
    '6xEKiGD2dTHt+yEW9WCuzJGdXUzJ+VeK19B2pQCaWbgZJyDHppP49tCtDOxN6vEJOGZdmnDf' +
    '3iIWlNCM6dC3JfMZtxB5pvB4lkB+/RHL6QC2lUIG9UCfPUHWxTCruKCdWiDM2qFOS8FrCTEm' +
    'lVINCbCs2aC9msEPXWHS8kC0M0EP/mIvX5/QAAAAAAAAAAACH5BAEAAHwALAAAAAAUABQAAA' +
    'f/gHyCg4SFhoQKVkY7HR1cWj0Kh4IHBG4qOCtVcTBZBAeHIBYvaQACAgB4G3JbFiCFCHQ2AA' +
    'UBAwMBBQAaJCxrCIM+YHMNYnp6e8nHDQkcLgsMgjpUbQXIe8jILXoTI080H4JDKAAByefnAQ' +
    'AiDhAZgg8xAgPo6AMCCSFHD4IGTvP1zt3LR8ZAPxnlAiZTJ+KEHYN8HiyZYO2YxYsjoCQJIi' +
    'hDlAQN9OQZSXKkHg5hzFwR9IGNCQ3HSprU86UOEi+CGCxgQmJDzAoV8hyb4kEItEEIpMwo8e' +
    'PisSYesBQBRigFkS53HESI4KCGEiBoyuQ4VGkMBDVweLw5c+PTJD4KDy5gkECBggQMFyS93V' +
    'soEAA7';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-sad.gif
  CSad =
    'data:image/gif;base64,R0lGODlhFAAUAOZ6AP/lIvrdH/HPGvzhIP7lIv7kIWNPHJqRd+' +
    '/MGc7QztXY2d/k6vbXHfLRG/3iIYx/X/DOGt7j6OvGF+K3EunCFvnbH3VkOpuSeXJgNMTDvW' +
    'FMGZ52CsbGwOS6FOa8FOW8FMvLyHRjOF5JFNWhC5mPdeW7FN+yEd2vEOK3E9CbCndnPWpQCW' +
    'hSH619B6SDD9WiDKJ8C2ZRHaiGD+a/Fr2MCZ6WfunHGXRjOcKkFa2PEtKyFruKCY9tCs2aC7' +
    'SNDm9WCtmnDWhLCNSfC8CSC/PUHdi3F8rLx5mQdt6vEPXWHZiOc+S8FsfHwefEGGxOB21QCL' +
    '6QC6eKEcjIw82qFJp+EI2BYYlkB2lNCJ2UfO7MGndmPGhTH3BeMc6dC97j6cnKxs6ZCd6wEN' +
    '6xEG9dL9msEMPDvMXFv5JyDJpvB9uuELaPDuvFF5twB+/RHOzJGdinDW9UCaaCDWxTCtOwFZ' +
    'txB7CTEmRPG/jbHkM0EP/mIuTq8gAAAAAAAAAAAAAAAAAAACH5BAEAAHoALAAAAAAUABQAAA' +
    'f/gHqCg4SFhoQLUjUqGhpaWEwLh4IKB3JROlluUy4rBwqHIBhUbXgBAXd4EEtnGCCFCVs4qQ' +
    'UEBAUDeA0UPiwJg15VdRV4AHnHeQAOeAIeMA8RgmY/RAPGeMjFAwwSaU8Zgkc5dwXH2OZ5BX' +
    'cIExskghZFAQTo6AQBAh1DFoIGNvP18mC7l6+LgX5NyCFbmG4dih4H9ViYw8Aaw2TbJIihcU' +
    'MQCRkCKjgwhkxZhWZA6CgRlAHOjAZ3cuGZOXMXkhROygiK8CAOBQh47py6kwSoiRFsoA1KEE' +
    'PNhzUIBAhAIOHDiREt7PwiZIQLDzITSpSYEOYNGCtjvhyqdGUDlBdCF3agCfJpkp4FHC6EEC' +
    'EixAUOkuwKLhQIADs%3D';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-cry.gif
  CCrying =
    'data:image/gif;base64,R0lGODlhEgASANcAAEM0EP///z/I9PC2AN3e3dLQys7MxOns76' +
    'vr/3BeMPfMAP/lIf/mI52Sd2BLF+ecAPfLAP/mIvvXDefq7dfX0+yrAPC3AKZxBPvaEe+xAP' +
    'rTCKCXfPvYD//kH/K9AMzKwf/jH1zX/+miAPzZEZCEY6GXfWRPHfjMAHhnPHdmO19JFO+yAP' +
    'fKAPbJAKRrBGhRHa+EA2hSHd+0Af7gGv3eGJCDYvbIAPG8AP7iHejr7p+Vep6UeLt3AppwBK' +
    '+KBM3Lw96uAfK/APC4ALGNA//lIsKLAm1NB+25ALGMA2BKFmlTHt+XAJ2TePjPBsqEAvbKAG' +
    '9TB6yBBM+NAeCTAGdQHJySdt+VAP/kIcyLAnFTB+aZAOyqAMKMAvLEAKZsA25OB61+A/PGAP' +
    'TMBsukAtSmAv3gGuOVAJ99BJhrBPO/AOemAJKGZnVjN/XHAHhmPKh2BGxLB/PCAP7hHOqpAP' +
    'rUCm9NB/TDAMvJwKVqA9euAnZlOvTEANfX0v3fGc6GAZViBPPBAHNXB/7iHnNiNfvXDvTCAG' +
    '5QB/vZEO7y9wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH/C05FVFNDQVBFMi' +
    '4wAwEAAAAh+QQJAQCIACwAAAAAEgASAAAI/wARCUR0wEAJFA4coChh4MDAhwQaQPGRp80eMl' +
    'EMNSDwEFGBBGfEABg5ksWRHgkKDKQQY4wEAAECwJR5wgMXJRQQTSAx5GVMmT8BQLDwZk2OD4' +
    'GazCQ5MiaAQnO+/GCCxKdMpk5bZLigg42MEQAQIGAadiyEAVLcOAgDNoSAtwDeCggBQMGAJS' +
    'aSdCEkhykDphierLBiYhAQDTRAXFkQgYHjBWXo2KngR08VGCw4zACxgEiECAtwYFAgRISXHX' +
    'ey3DjBYWSHDoL6jExTwUydDxNqgPEAQMMhpgqCAHiAh8QERHyoFBkAyAYEBS3iWNjygMeLnA' +
    'I/olGTYcCAFRVETB35k7JjRCMXsDzQ4sQFnI0dBRbckEKFihQbGj4MCAAh+QQJAQCIACwAAA' +
    'AAEgASAAAI/wARCUR0wEAJFA4coChh4MDAhwQaQPGRp80eMlEMNSDwEFGBBGfEABg5ksWRHg' +
    'kKDKQQY4wEAAECwJR5wgMXJRQQTSAx5GVMmT8BQLDwZk2OD4GazCQ5MiaAQnO+/GCCxKdMpk' +
    '5bZLigg42MEQAQIGAadiyEAVLcOAgDNoSAtwDeCggBQMGAJSaSdCEkhykDphierLBiYhAQDT' +
    'RAXFkQgYHjBWXo2KngR08VGCw4zACxgEiECAtwYFAgRISXHXey3DjBAUCEDiP7YACQpoKZOh' +
    '8m1ADj4YSGkYIEjQxS4QEeEhMQ8aFSZAAgGxAUtIhjYcsDHi9yCvyIRk2GAQNWVB8QMeVPyo' +
    '4RjVzA8kCLExdwNnYUWHBDChUqUmxo+DAgACH+E6kyMDAzIC0gSG9vc2llckR1ZGUAOw%3D%' +
    '3D';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-cool.gif
  CCool =
    'data:image/gif;base64,R0lGODlhFAAUAOZ8APrdH/jbHvzhIP/lIvHPGv7lIv7kIfnbH+' +
    '/y9N3d2GVQHf3iIeTl4+nCFqKYfPbXHe7x8u/MGZKFY+vGF3hnPNHPxV9JFOW7FPDOGvXWHe' +
    'K3Ev///9jY0fLRG9TSyea8FOW8FKGWeuS6FHVjNtWhC3dmOmJNGaOZfuS8FptwB619B2pQCc' +
    '2aC9msEN2vENWiDOvFF+a/Fp+VeNDOxIlkB29UCdi3F4NiDKJ8C5JyDOzJGW9WCqeKEZ52Ct' +
    'jX0GlVINinDd6wEMKkFY10EaiGD9CbCraPDs6ZCWZQHKeehKWbgXNhM+K3E9uuENLQx9OwFa' +
    'aCDZp+ENmnDZtxB2xOB+7MGo9tCunHGc6dC3ppP7uKCWhLCNTTymdTHmxTCmlUINfWz7SNDq' +
    'GXe9KyFm1QCN+yEbCTEu/RHGlNCJpvB96vEOfEGL6QC9XUzL2MCaSDD3hmO5OGZfPUHc2qFN' +
    '6xEHJfMe/y83tqQNSfC8CSC//mIkM0EPX5/QAAAAAAAAAAACH5BAEAAHwALAAAAAAUABQAAA' +
    'f/gHyCg4SFhoQIbUl3JiZZSlwIh4IMDl48Y1U6c28rDgyHHCNRZwEAAAEZGCg5IxyFCT9CAQ' +
    'IGBQUGAgEdDWFfCYN2cWYHCwN6yHoDCwcEHzgSEIJOO3ICe9h7etl7DxNNZBWCYkPcG+bcNy' +
    'GCFDYABdzb2QAEInkUggpX79nJ8/VYFORbE8BAsoN6DASIwISFQD4UnjwQcAzhAAHe6LiBIy' +
    'gEEQLFKiJbdmDPBylTZAiqUCNGB1q2cAko2UBNESozBEGQAKUBhgymAGRrUIZEimiDEnQxAg' +
    'JGBAIEIkwA4YKECiTACPlYYqWFhgsXNAQBcoRGHTCHKqHpweYFHi1pFbZ8msQHgYcTJSxYKH' +
    'HCgyS6gAsFAgA7';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-mad.gif
  CMad =
    'data:image/gif;base64,R0lGODlhFAAUAOZ6APrdH/HPGvzhIP/lIv7lIv7kIfnbH2VQHf' +
    '3iIe/MGd3d2KKYfO/y9OTl4+nCFvbXHevGF5KFY3hnPO7x8vLRG+K3El9JFPDOGtWhC6OZft' +
    'jY0fXWHXVjNtTSyeW7FOa8FOW8FGJNGdHPxXdmOqGWeuS6FJ52CpJyDNuuEO7MGmlUIGpQCW' +
    'lNCJtxB2dTHt6wEL6QC86ZCeS8FtinDcKkFWxOB+/RHNXUzOzJGaiGD5p+EK2PEnppP9CbCm' +
    'lVIN2vEKGXe82aC9OwFdKyFtfWz6Wbgdi3F3NhM9SfC9+yEY9tCpOGZaeehG9UCenHGWhLCL' +
    'uKCaJ8C9LQx9jX0J+VeOa/Fs2qFHhmO9DOxOfEGNmsEN6vEHtqQMCSC21QCGZQHLCTEtWiDK' +
    'eKEZpvB+K3E4lkB6aCDdmnDW9WCt6xEOvFF7SNDu/y89TTyraPDnJfMaSDD86dC2xTCq19B5' +
    'twB72MCfPUHfjbHkM0EP/mIvX5/QAAAAAAAAAAAAAAAAAAACH5BAEAAHoALAAAAAAUABQAAA' +
    'f/gHqCg4SFhoQMN0xcISE8RW0Mh4INC3JiQyk4VnArCw2HGhw6NncAAHcbFzInHBqFCj40dw' +
    'IFBAQFAncUDmsqCoNsS2AGCAN5yHkDCAYBH1ERE4JSaHYCeHjJyNgPECheIoJAO3cF28nZBX' +
    'cJFSYkghJGAATb2dh5BAABJV0SggdO5tXLcy/fvjgH/mUpp02bugRkgiTUI0HIAwHHGg4Q0C' +
    '1NnSuCSOQIUCwjsmXNPpxpQUWQiCZVKNDCRtMAry09amARNCGCGQcX8JhCtQGPgyQY6EQbpM' +
    'CFGxBqEgQIkAACiB8Y5nwBRmjKESVaKnjwUOHFjBhl3hA5VImFCRhhGJBAGfPk0yQ9DDpkGG' +
    'HBwogMHSTdHVwoEAA7';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-wink.gif
  CWinking =
    'data:image/gif;base64,R0lGODlhFAAUAOZ2AP7lIvjbHvzhIPnbH/HPGv7kIf/lInJfMd' +
    'fWz6CWeeK3Et3d2P3iIe/MGfrdH+Tl4u/y9NTSyenCFuW8FGFMF+7x8vbXHfDOGvLRG+S6FF' +
    '9JFPXWHZx1CtHPxd6wEGVQHaSbgPreH3ppPuvFF+vGF5OGZdWhC3hnPKSaf72MCWBLFs6bC7' +
    'eQDvTVHZhuB+3MG2tPCNmsEL2QC+fAFnVjNtyvEJRzDMaoFqx8B+S6E9DOxNSfC3FYC29UCe' +
    'S9FqmHD+a8FMCSC2dSHKGXe62PEmhMCKaFD5+VeNWiDM2qFNinDWpOCNmnDc6ZCd6vEJ55C6' +
    'GWeqOZfYtlB9m5GHhmO+/RHJt/EKuNEWdSHW5UCppvB6WCDd+yEZKGZO3KGdGbCs6cC7qJCd' +
    '2vEGlUH5WJaHZkONezFmtRCe/NGq6REu/y87iQDuvKGtLQx3loPWtOB2hUHZluB9KyFpFuCk' +
    'M0EP/mIvX5/QAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAHYALAAAAAAUABQAAA' +
    'f/gHaCg4SFhoQQESAiFBQiIBEQh4IPCVlXcmheSUZnCQ+HCAdWVQEODgEbFz42BwiFC3A3AQ' +
    'IFAAAFAgEYEmtjC4MVJWkDDAZ1yHUGDAMEE09kaoIdPC0Cx8l1dAYCFiQ1MG2CUEQDBdp0dM' +
    'jqBQENChxRgmVTIQDZ63UADgQ5QW6CKLywhy/ZPgIZwHwQpIKNuYLI2r1bsdAODTMW0hXk5s' +
    '1DCiqCjvwgUExdsmXNgDDRMkSQjh4zMAwQQOdWLjq8nHx500FQhS5bJFzYECBdugsSuJiIU6' +
    'LCoAVCWEwY0YAAgQYjJogxgQMLMEKi5sRQkCGDAg9KmkhxdajSEg4yF5DsCOOiyKdJdhKhOK' +
    'FBwwkUkfAKNhQIADs%3D';

  //http://www.smiley-faces.org/smiley-faces/smiley-face-ohmy.gif
  CSurprised =
    'data:image/gif;base64,R0lGODlhFAAUAOZ7AP/lIvrdH/7lIv7kIfHPGvzhIOTl4+/y9O' +
    'nCFt3d2GVQHaKYfPnbH+/MGZKFY+7x8v3iIfbXHfLRG+K3EvDOGnhnPOW8FOS6FOa8FKOZfu' +
    'W7FNjY0f8CAPXWHXVjNp52CmJNGV9JFHdmOqGWetTSydHPxdWhC+vGF9jX0Ni3F9TTymxOB9' +
    'DOxKJ8C7SNDnJfMWlNCOzJGdmsENLQx+S8FsCSC5JyDOa/FtuuEM2aC3tqQO7MGmlVIN6xEG' +
    'lUIPPUHWxTCr6QC2hLCL2MCa2PEqaCDdCbCraPDtSfC9mnDe/RHJ+VeN+yEd6wEG9WCmdTHp' +
    'pvB86ZCWpQCa19B9inDenHGZp+ELCTEsKkFeK3E6eKEe/y829UCaiGD86dC6SDD6WbgdXUzK' +
    'eehJOGZbuKCYlkB21QCGZQHM2qFJtxB9OwFevFF9fWz3hmO5twB92vEI9tCufEGKGXe9WiDH' +
    'NhM96vENKyFnppP/jbHkM0EP/mIvX5/QAAAAAAAAAAAAAAACH5BAEAAHsALAAAAAAUABQAAA' +
    'f/gHuCg4SFhoQHYWI6ICB3YCoHh4IGC0BadjsxaF9SCwaHGx5WSngBAXgdFDQ2HhuFCTxYeH' +
    'l5AgIDtRIILj4Jg1tjVwx5AHrHegAQeQQYLQ4PgjNOPwXGecjFBREnOGYlgnJEeAPH2OZ6A3' +
    'gNEx8jghUpAQLo6AIBBBc1FYIKVfPIAuq5l8+Lgn5xyAlEpq5BlhwH91RQE8HaQgDbTvQY0k' +
    'bQiC4EGEC4VisPBAbNkqRZIqgElxsS8BTIVZLBrjpGVrAQ9MBBEQQUOtDiwCEPBQRMTLiBNi' +
    'jBkyMW1jQomcfCGxNTzvwihIIOHBkTNGiY0IRKlDIv2ByqBONDkDlIF8hAEfJp0p4DJDKICB' +
    'FCRAYSkuwKLhQIADs%3D';

{ TSmiley }

function TSmiley.EmotionName: string;
begin
  Result := CEmotionName[FEmotion];
end;

function TSmiley.GetEmotionData(emotion: TSmileyEmotion): string;
const
  EmotionData: array [seSmiling..seSurprised] of string =
    [CSmiling, CGrinning, CLaughing, CSad, CCrying, CCool, CMad,
     CWinking, CSurprised];
begin
  Result := EmotionData[emotion];
end;

procedure TSmiley.InitializeObject; 
begin
  inherited;
  Emotion := seSmiling;
end;

procedure TSmiley.SetEmotion(const emotion: TSmileyEmotion);
begin
  FEmotion := emotion;
  InnerHTML := '<img valign="middle" align="middle" alt="" ' +
    'src="' + GetEmotionData(emotion) + '" />';
end;

procedure TSmiley.StyleTagObject;
begin
  inherited;
  StyleClass := 'TW3Image';
end;

end.
